import datetime
import math

class data_struct:
    retezec = ""
    realne_cislo = 0.0


VELIKOST_POLE = 2000


def main(argv=None):

    zacatek = datetime.datetime.now()

    data = list(data_struct() for i in range(VELIKOST_POLE))

    data[0].realne_cislo = 5.154

    for i in range(1, VELIKOST_POLE):
        r = data[i-1].realne_cislo * 10.0
        r = (r - int(r)) * 7 + 2 + (i % 10)/10.0
        r = math.log(r, 10)
        r = r * 10000
        r = math.floor(r)
        data[i].realne_cislo = r / 1000

    for d in data:
        d.retezec = "X"  + str(d.realne_cislo)

    serazeno = False
    zacatek_cyklu = datetime.datetime.now()
    pocet_porovnani = 0
    pocet_prohozeni = 0

    while (not serazeno):
        serazeno = True
        for i in range(1, VELIKOST_POLE):
            pocet_porovnani += 1
            if (data[i-1].retezec > data[i].retezec):
                pocet_prohozeni += 1
                data[i], data[i-1] = data[i-1], data[i]
                serazeno = False
                break

    konec = datetime.datetime.now()

    print ("Test 3 Jsem hotov, trvalo mi to " + str((konec-zacatek).total_seconds()) + " sekund, pocet porovnani/prohozeni " + str(pocet_porovnani) + "/" + str(pocet_prohozeni))
    print ("Cyklus trval " + str((konec-zacatek_cyklu).total_seconds()) + " sekund")
    # print(' '.join(str(d.realne_cislo) for d in data))

main()
