<html>
<head>
  <title>Test 4</title>
  <meta charset="utf8">
</head>
<body>
<?php 

$VELIKOST_POLE = 2000;
$MAX_DELKA_REZEZCE = 6;

class data_struct {
  public $retezec;
  public $realne_cislo;
  public function __construct($retezec, $realne_cislo) {
    $this->retezec = $retezec;
    $this->realne_cislo = $realne_cislo;
  }
}


$zacatek = microtime(true);

// vytvorime v pameti pole struktur
$data = array_fill(0, $VELIKOST_POLE, 0);
for ($i = 0; $i < $VELIKOST_POLE; $i++) {
    $data[$i] = new data_struct("0.0", 0.0);
}

// naplnime nejakymi daty
$data[0]->realne_cislo = 5.154; 
for ($i = 1; $i < $VELIKOST_POLE; $i++) {
    $r = $data[$i - 1]->realne_cislo * 10.0;
    $r = ($r - floor($r)) * 7 + 2.0 + ($i % 10)/10.0;
    $r = log10($r);
    $r = $r * 10000.0;
    $r = floor($r);
    $data[$i]->realne_cislo = $r / 1000.0;
}
// prevedeme na retezec a na cele cislo
for ($i = 0; $i < $VELIKOST_POLE; $i++) {
    $data[$i]->retezec = sprintf("X%1.3f", $data[$i]->realne_cislo);
//    echo $data[$i]->retezec . " " . $data[$i]->realne_cislo . "<br/>";
}
// seradime podle retezcu
$serazeno = false;
$zacatekCyklu = microtime(true);
$pocetPorovnani = 0;
$pocetProhozeni = 0;
while (!$serazeno) {
    $serazeno = true;
    for ($i = 1; $i < $VELIKOST_POLE; $i++) {
        $pocetPorovnani++;
        if (strcmp($data[$i - 1]->retezec, $data[$i]->retezec) > 0) {
//            if ($data[$i - 1]->realne_cislo > $data[$i]->realne_cislo) {
            $pocetProhozeni++;
            $prehoz = $data[$i];
            $data[$i] =  $data[$i - 1];
            $data[$i - 1] = $prehoz;
            $serazeno = false;
            break;
        }
    }
}

$konec = microtime(true);
echo "Test 4 Jsem hotov, trvalo mi to " . ($konec - $zacatek) . "s, pocet porovnani/prohozeni " . $pocetPorovnani . "/" . $pocetProhozeni . " <br/>";
echo "Cyklus trval " . ($konec - $zacatekCyklu) . " s<br/";

?>  
</body>
</html>
