﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IB053_test
{
    class Program
    {

        private static readonly int VELIKOST_POLE = 2000;


        public static void test()
        {
            bool serazeno;
            DateTime zacatek = DateTime.Now;

            Console.WriteLine("Test");
            // vytvorime v pameti pole struktur
            data_struct[] data = new data_struct[VELIKOST_POLE];
            for (int i = 0; i < VELIKOST_POLE; i++)
            {
                data[i] = new data_struct();
            }

            // naplnime nejakymi daty
            data[0].realne_cislo = 5.154;
            for (int i = 1; i < VELIKOST_POLE; i++)
            {
                double r = data[i - 1].realne_cislo * 10f;
                r = (r - (int)r) * 7 + 2 + (i % 10) / 10.0;
                r = Math.Log10(r);
                r = r * 10000;
                r = Math.Floor(r);
                data[i].realne_cislo = r / 1000;
            }
            // prevedeme na retezec a na cele cislo
            for (int i = 0; i < VELIKOST_POLE; i++)
            {
                data[i].retezec = "X" + data[i].realne_cislo;
                //System.out.println("" + i + " - " + data[i].retezec);
            }
            // seradime podle realnych cisel
            DateTime zacatekCyklu = DateTime.Now;
            serazeno = false;
            long pocetPorovnani = 0;
            long pocetProhozeni = 0;
            while (!serazeno)
            {
                serazeno = true;
                for (int i = 1; i < VELIKOST_POLE; i++)
                {
                    pocetPorovnani++;
                    if (String.Compare(data[i - 1].retezec, data[i].retezec, StringComparison.Ordinal) > 0)
                    //if (data[i - 1].realne_cislo > data[i].realne_cislo)
                    {
                        pocetProhozeni++;
                        data_struct prehoz;
                        prehoz = data[i];
                        data[i] = data[i - 1];
                        data[i - 1] = prehoz;
                        serazeno = false;
                        break;
                    }
                }
            }
            DateTime konec = DateTime.Now;
            Console.WriteLine("4 Jsem hotov, trvalo mi to " + (konec - zacatek).TotalMilliseconds / 1000f + " s, pocet porovnani/prohozeni " + pocetPorovnani + "/" + pocetProhozeni);
            Console.WriteLine("Trideni trvalo " + (konec - zacatekCyklu).TotalMilliseconds / 1000f + " sekund");
        }



        static void Main(string[] args)
        {
            test();
        }
    }
}
