package cz.muni.fi.ib053;

import cz.muni.fi.ib053.Test1_fce.data_struct;

public class Test1 {
	
	private static final int VELIKOST_POLE = 2000;
	

	public static void test() {
		boolean serazeno;
		long zacatek = System.currentTimeMillis();

		System.out.println("Test1 prohozeni funkci");
		// vytvorime v pameti pole struktur
		data_struct [] data = new data_struct[VELIKOST_POLE];
		for (int i = 0; i < VELIKOST_POLE; i++) {
			data[i] = new data_struct();
		}

		// naplnime nejakymi daty
		data[0].realne_cislo = 5.154; 
		for (int i = 1; i < VELIKOST_POLE; i++) {
			double r = data[i - 1].realne_cislo * 10f;
			r = (r - (int)r) * 7 + 2 + (i % 10)/10.0;
			r = Math.log10(r);
			r = r * 10000;
			r = Math.floor(r);
			data[i].realne_cislo = r / 1000;
		}
		// prevedeme na retezec a na cele cislo
		for (int i = 0; i < VELIKOST_POLE; i++) {
			data[i].retezec = "X" + data[i].realne_cislo; 
			//System.out.println("" + i + " - " + data[i].retezec);
		}
		// seradime podle realnych cisel
		long zacatekCyklu = System.currentTimeMillis();
		serazeno = false;
		long pocetPorovnani = 0;
		long pocetProhozeni = 0;
		while (!serazeno) {
			serazeno = true;
			for (int i = 1; i < VELIKOST_POLE; i++) {
				pocetPorovnani++;
				//if (data[i - 1].retezec.compareTo(data[i].retezec) > 0) {
				if (data[i - 1].realne_cislo > data[i].realne_cislo) {
					pocetProhozeni++;
					Test1_fce.prohod(data, i, i - 1);
					serazeno = false;
					break;
				}
			}
		}
		long konec = System.currentTimeMillis();
		System.out.println("Jsem hotov, trvalo mi to " + (konec - zacatek)/1000f + " s, pocet porovnani/prohozeni " + pocetPorovnani + "/" + pocetProhozeni);
		System.out.println("Trideni trvalo " + (konec - zacatekCyklu)/1000f + " sekund");
	}


}
