package cz.muni.fi.ib053;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import cz.muni.fi.ib053.Test1_fce.data_struct;

public class Test1R {
	
	private static final int VELIKOST_POLE = 2000;
	

	public static void test() {
		boolean serazeno;
		long zacatek = System.currentTimeMillis();

		System.out.println("Test1R prohozeni funkci + reflection");
		// vytvorime v pameti pole struktur
		data_struct [] data = new data_struct[VELIKOST_POLE];
		for (int i = 0; i < VELIKOST_POLE; i++) {
			data[i] = new data_struct();
		}

		// naplnime nejakymi daty
		data[0].realne_cislo = 5.154; 
		for (int i = 1; i < VELIKOST_POLE; i++) {
			double r = data[i - 1].realne_cislo * 10f;
			r = (r - (int)r) * 7 + 2 + (i % 10)/10.0;
			r = Math.log10(r);
			r = r * 10000;
			r = Math.floor(r);
			data[i].realne_cislo = r / 1000;
		}
		// prevedeme na retezec a na cele cislo
		for (int i = 0; i < VELIKOST_POLE; i++) {
			data[i].retezec = "X" + data[i].realne_cislo; 
			//System.out.println("" + i + " - " + data[i].retezec);
		}
		// seradime podle retezcu
		long zacatekCyklu = System.currentTimeMillis();
		serazeno = false;
		long pocetPorovnani = 0;
		long pocetProhozeni = 0;
		Method method;
		try {
			Class clsTest1_fce = Class.forName("cz.muni.fi.ib053.Test1_fce");
			method = clsTest1_fce.getMethod("prohod", data_struct [].class, int.class, int.class);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			return;
		} catch (SecurityException e) {
			e.printStackTrace();
			return;
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
			return;
		}
		try {
			while (!serazeno) {
				serazeno = true;
				for (int i = 1; i < VELIKOST_POLE; i++) {
					pocetPorovnani++;
					//if (data[i - 1].retezec.compareTo(data[i].retezec) > 0) {
					if (data[i - 1].realne_cislo > data[i].realne_cislo) {
						pocetProhozeni++;
						method.invoke(null, data, i, i - 1);
						//Test1_fce.prohod(data, i, i - 1);
						serazeno = false;
						break;
					}
				}
			}
		} catch (IllegalAccessException e) {
			e.printStackTrace();
			return;
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
			return;
		} catch (InvocationTargetException e) {
			e.printStackTrace();
			return;
		}
		long konec = System.currentTimeMillis();
		System.out.println("Jsem hotov, trvalo mi to " + (konec - zacatek)/1000f + " s, pocet porovnani/prohozeni " + pocetPorovnani + "/" + pocetProhozeni);
		System.out.println("Trideni trvalo " + (konec - zacatekCyklu)/1000f + " sekund");
	}


}
